% This script illustrates anonymous functions
%
clc
disp('                        Anonymous Functions')
disp(' ')
disp('Another way to perform the circle calculations is to use anonymous functions.')
disp('This can be done directly at the command prompt (or in our current file).')
disp('We type')
disp('>> circumference = @(r) 2*pi*r')
circumference = @(r) 2*pi*r
disp('Paused...Please hit a key to continue')
pause
disp('and')
disp('>> area = @(r) pi*r.^2')
area = @(r) pi*r.^2
disp('Paused...Please hit a key to continue')
pause

disp('Anonymous functions are evaluated like standard math functions.')
disp('To get the circumference of a circle with radius 5 we use')
disp('>> circumference(5)')
circumference(5)
disp('Paused...Please hit a key to continue')
pause

disp('To get both values we use, e.g.,')
disp('>> circledata = [circumference(5); area(5)]')
circledata = [circumference(5); area(5)]
disp('Paused...Please hit a key to continue')
pause

disp('Vectorized usage:')
disp('>> circledata = [circumference([2 4 6]); area([2 4 6])]')
circledata = [circumference([2 4 6]); area([2 4 6])]

